# This file contains a JSONSchema to validate the values given
# as inputs to the chart.
#
# **** How to edit this file *****
#
# This file is encoded as YAML instead of JSON to allow comments,
# and make editing and diffing easier.
#
# The values.schema.json file is the file actually used by the Helm chart
# and MUST BE RECREATED after each modification of this file:
#
#   ./utils/_yaml2json.py < values.schema.yaml > values.schema.json

$schema: https://json-schema.org/draft/2020-12/schema#

title: Schema for libvirt-metal chart values

additionalProperties: false

$defs:
  memGB:
    type: integer
    minimum: 2

  numCPUs:
    type: integer
    minimum: 2

  port:
    type: integer
    minimum: 1024
    maximum: 65535

properties:

  redfishPath:  # -------------------------------
    type: string

  clusterVirtualIp:  # -------------------------------
    type: string
    format: ipv4

  clusterPublicIP:  # -------------------------------
    type: string
    format: ipv4

  clusterPublicDomain:  # -------------------------------
    type: string
    format: hostname

  clusterApiPublicPort:  # -------------------------------
    $ref: "#/$defs/port"

  clusterServicePublicPort:  # -------------------------------
    $ref: "#/$defs/port"

  image:  # -------------------------------
    type: string

  memGB:  # -------------------------------
    $ref: "#/$defs/memGB"

  numCPUs:
    $ref: "#/$defs/numCPUs"

  useBond:  # -------------------------------
    type: boolean

  enableDHCP:  # -------------------------------
    type: boolean

  nodes:  # -------------------------------
    type: object
    additionalProperties: false
    maxProperties: 100  # As we are using a 2 digits number to represent NODE_INDEX
    patternProperties:

      "^[a-z0-9][a-z0-9-]*[a-z0-9]$":  # -------------------------------
        type: object
        additionalProperties: false
        required:
        - redfishPort
        properties:

          image:  # -------------------------------
            type: string

          memGB:  # -------------------------------
            $ref: "#/$defs/memGB"

          numCPUs:  # -------------------------------
            $ref: "#/$defs/numCPUs"

          redfishPort:  # -------------------------------
            $ref: "#/$defs/port"

          useBond:  # -------------------------------
            type: boolean

          enableDHCP:  # -------------------------------
            type: boolean
